<?php

namespace Drupal\spammaster;

use Symfony\Component\HttpFoundation\RequestStack;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Class service.
 */
class SpamMasterCollectService {

  /**
   * Symfony\Component\HttpFoundation\RequestStack definition.
   *
   * @var \Symfony\Component\HttpFoundation\RequestStack
   */
  protected $requestStack;

  /**
   * The form class.
   *
   * @var \Drupal\Core\Form\FormInterface
   */
  protected $collectnow;

  /**
   * {@inheritdoc}
   */
  public function __construct(RequestStack $requestStack) {
    $this->requestStack = $requestStack;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('request_stack')
    );
  }

  /**
   * {@inheritdoc}
   */
  public function spamMasterGetCollect($collectnow) {

    $this->collectnow = $collectnow;
    // Get remote ip.
    $spammasterip = $this->requestStack->getCurrentRequest()->getClientIp();
    // Get remote agent.
    if (isset($_SERVER['HTTP_USER_AGENT'])) {
      $spammasteragent = htmlentities($_SERVER['HTTP_USER_AGENT'], ENT_QUOTES, 'UTF-8');
    }
    else {
      $spammasteragent = 'Sniffer';
    }
    // Get remote referrer.
    if (isset($_SERVER['HTTP_REFERER'])) {
      $spammasterreferer = substr(htmlentities($_SERVER['HTTP_REFERER'], ENT_QUOTES, 'UTF-8'), 0, 360);
    }
    else {
      $spammasterreferer = 'Direct';
    }
    // Get remote uri.
    if (isset($_SERVER['REQUEST_URI'])) {
      $spammasterurl = substr(htmlentities($_SERVER['REQUEST_SCHEME'] . '://' . $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'], ENT_QUOTES, 'UTF-8'), 0, 360);
    }
    else {
      $spammasterurl = 'Weird';
    }

    return [
      'spammasterip'      => $spammasterip,
      'spammasteragent'   => $spammasteragent,
      'spammasterreferer' => $spammasterreferer,
      'spammasterurl'     => $spammasterurl,
    ];

  }

}
